# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, gamethread, os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
core    = es.import_addon('sam/core')
monitor = es.import_addon('sam/core/monitor')
admins  = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp = {'nextlevel':None}
path = 'cstrike/maps/'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# ADD MAIN PAGE OPTION
	monitor.addons.append('mapchange')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# REMOVE MAIN PAGE OPTION
	monitor.addons.remove('mapchange')

	# CANCEL DELAY
	gamethread.cancelDelayed('sam_mapchange_delay')

	# POPUPS
	func.popupDelete('mapChange')
	func.popupDelete('whenToChange')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID):
	if admins.can(ID,'Map Change'):
		func.popupDelete('mapChange')
		popup = func.easymenu(popuplib.easymenu('mapChange', None , mapChangeChoice),'home')
		popup.settitle(func.header(func.langAddon('mapchange','TITLE')))
		for item in mapList(): popup.addoption(item, item)
		popup.send(ID)
	else: core.home(ID)

# ------------------------------------------------------------------------------- #
def mapChangeChoice(ID, MAP, POPUP):
	func.popupDelete('whenToChange')
	popup = func.easymenu(popuplib.easymenu('whenToChange', None , whenToChangeChoice),'mapChange')
	popup.settitle(func.header(func.langAddon('mapchange','TITLE')))
	popup.addoption([1,MAP], func.langAddon('mapchange','CHANGE_NOW'))
	popup.addoption([2,MAP], func.langAddon('mapchange','CHANGE_ROUNDEND'))
	popup.send(ID)

# ------------------------------------------------------------------------------- #
def whenToChangeChoice(ID, TOKENS, POPUP):
	gamethread.cancelDelayed('sam_mapchange_delay')
	if TOKENS[0] == 1: change(TOKENS[1])
	elif TOKENS[0] == 2:
		temp['nextlevel'] = TOKENS[1]
		func.tell('#all',func.langAddon('mapchange','CHANGING_ROUNDEND',{'map':TOKENS[1]}),func.servertag)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def change(MAP):
	func.hudhint('#all',func.langAddon('mapchange','CHANGING_MAP',{'map':MAP}),func.servertag)
	func.tell('#all',func.langAddon('mapchange','CHANGING_MAP',{'map':MAP}),func.servertag)
	gamethread.delayedname(5, 'sam_mapchange_delay', es.server.insertcmd, ('changelevel %s' % MAP))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def mapList(): return [item.replace('.bsp','') for item in os.listdir(path) if os.path.isfile(path + item) and item.endswith('.bsp')]

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def round_end(ev):
	if temp['nextlevel']:
		change(temp['nextlevel'])
		temp['nextlevel'] = None

# =============================================================================== #