# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es, gamethread, os, random, cmdlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
monitor = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
path = 'cstrike/cfg/sam_config/adverts.txt'
temp = {'last':'None','delay':30}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CREATE CFG
	createFile()

	# CMD
	cmdlib.registerServerCommand('sam_adverts_delay', delayCMD, 'SAM CMD')

	# CFG
	lib = {'sam_adverts_delay':{'value':temp['delay'],'description':'Adverts Delay: Delay in seconds between each advert message.'},
		   'addon':monitor.get('adverts','name')}
	monitor.cfg('adverts', lib)

	# START LOOP
	gamethread.delayedname(5, 'sam_adverts_loop', send, ())

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	cmdlib.unregisterServerCommand('sam_adverts_delay')

	# CANCEL DELAY
	gamethread.cancelDelayed('sam_adverts_loop')

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def send():
	list = getAds()
	try: list.remove(temp['last'])
	except: pass
	temp['last'] = str(random.choice(list))
	func.tell('#all', temp['last'],False,False)
	gamethread.delayedname(temp['delay'], 'sam_adverts_loop', send, ())

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getAds():
	if os.path.isfile(path):
		with open(path) as f: return [line.strip('-').strip(' ').strip('\n') for line in f.readlines() if line.startswith('-')]
	else: return []

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def delayCMD(args):
	if args:
		args = ' '.join(args)
		if args.isdigit(): temp['delay'] = int(args)

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def createFile():
	if not os.path.isfile(path):
		f = open(path,'w')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Adverts file #\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  # How to edit?\n')
		f.write('#  >> Start a new line with -, and write whatever you want.\n')
		f.write('#  >> Use colors to colorize your messages.\n')
		f.write('#\n')
		f.write('#  COLORS:\n')
		f.write('#  #red, #green, #blue, #pink, #yellow, purple, #cyan, #beige, #grey\n')
		f.write('#  #white, #black, dimgrey, #ct, #t, #spec, #default, #lightgreen\n')
		f.write('#\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n \n')
		f.write('- #beigeWelcome to our server, have fun! :)\n')
		f.write('- #beigeIf you like this server, add it to favourites!\n')
		f.write('- #beigeType #t!admins #beigeto see online #cyanAdmins #beigein case you need help.\n')
		f.write('- #beigeWant to go to #specSpectators#beige? Then type #t!spec#beige.\n')
		f.write('- #beigeRespect our server #t!rules#beige.\n')
		f.write('- #beigeCall some friends to join the server.')
		f.close()

# =============================================================================== #